/**
 * @bZ[W{bNXNX.
 * <BR>@										2001 / 3 // Ayusya
 */
import java.util.Hashtable;
import java.awt.Dialog;
import java.awt.Button;
import java.awt.Label;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.Panel;
import java.awt.Point;
import java.awt.Dimension;
import java.awt.Window;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
/**
 * @bZ[W{bNX\NX.
 * <BR>@_CAOɃbZ[W\AtOɂĎw肳ꂽ{^zuB
 * <BR>@{^\킷ID߂lŕԂAǂ̃{^ꂽ\킷B
 * <BR>@IDMessageBoxValuesC^[tF[XŒ`BĂяo͂̃C^[tF[X
 * p邱ƂŁAIDgpłB
 */
public class MessageBox extends WindowAdapter
	implements ActionListener, MessageBoxValues
{
	/**
	 * @IDϊp̃nbVe[uB.
	 * <BR>@{^IDƃ{^ɕ\LvVƂ𑊌݂ɕϊׂ̃e[uB
	 */
    private static Hashtable trans = new Hashtable();

	/**IDƕo^*/
	private static void put( int id, String st ) {
		trans.put( new Integer( id ), st );
		trans.put( st, new Integer( id ) );
	}
	/**
	 * @X^eBbNubN.
	 * <BR>@IDϊp̃nbVe[uB
	 */
    static {
        put( MB_YES, MB_ST_YES );
        put( MB_OK, MB_ST_OK );
        put( MB_ABORT, MB_ST_ABORT );
        put( MB_NO, MB_ST_NO );
        put( MB_RETRY, MB_ST_RETRY );
        put( MB_CANCEL, MB_ST_CANCEL );
        put( MB_IGNORE, MB_ST_IGNORE );
    }
	/**
	 * @IDϊe[ugpāAID當߂B.
	 * <BR>@
	 */
    private static String toString( int id ) {
        String st = ( String )trans.get( new Integer( id ) );
        return st == null ? "" : st;
    }
	/**
	 * @IDϊe[ugpāA񂩂ID߂B.
	 * <BR>@
	 */
    private static int toID( String st ) {
        Integer ans = ( Integer )trans.get( st );
        return ans == null ? MB_CANCEL : ans.intValue();
    }
	/**w肳ꂽ{^IDۑ*/
    private int ans = 0;
	/**_CAOIuWFNg*/
    private Dialog dlg = null;
	/**EBhE\ꂽɁAŏɃtH[JXݒ肷{^ۑ񂷂B*/
    private Button btnFocus = null;
	/**
	 * @OĂяoAbZ[W{bNXsB.
	 * <BR>@MessageBoxNX̃CX^X𐶐AshowDialog()ɂĂsB
	 * @param f _CAO̐eEBhEBW̊ɂȂB
	 * @param msg \郁bZ[WB
	 * @param title \EBhEɕtEBhE^CgB
	 * @param flag \{^̎ނƁAftHgŃtH[JX{^w肷B
	 */
    public static int show( Frame f, String msg, String title, int flag ) {
        //@Cxgp̃CX^X쐬
        MessageBox mb = new MessageBox();
        return mb.showDialog( f, msg, title, flag );
    }
    //@\ƏI
    private int showDialog( Frame f, String msg, String title, int flag ) {
        //@\_CAO쐬
        dlg = new Dialog( f, title, true );
        dlg.setLayout( new BorderLayout() );
        //@xǉ
        addMessage( dlg, msg );
        Panel p = new Panel();
		p.setLayout( new FlowLayout( FlowLayout.CENTER, 20, 10 ) );
        //@{^ǉ
        int i = 0;
        Button[] b = new Button[ 5 ];
        for( int id = 1; id <= MB_LAST_BUTTON_ID; id <<= 1 ) {
            if( ( flag & id ) != 0 ) {
				b[ i ] = new Button( toString( id ) );
				b[ i ].addActionListener( this );
				p.add( b[ i ] );
				i++;
			}
        }
        //@addɂĐݒ肳ꂽpl_CAOɒǉ
        dlg.add( p, BorderLayout.SOUTH );
        //@tH[JXݒ
        if( ( flag & MB_BUTTON2 ) != 0 && i >= 2 ) btnFocus = b[ 1 ];
        else if( ( flag & MB_BUTTON3 ) != 0 && i >= 3 ) btnFocus = b[ 2 ];
        //@_CAO̐ݒ
        dlg.setResizable( false );
        dlg.addWindowListener( this );
		setPosition( f, dlg );
        //@_CAO\
        dlg.show();
        return ans;
    }
	/**
	 * @.
	 * <BR>@
	 */
    //@bZ[W_CAOɔzu@sƂLabel쐬
    public static void addMessage( Dialog dlg, String msg ) {
		Panel p = new Panel();
		p.setLayout( new GridLayout( 0, 1 ) );
		int n = 0, offset = 0, offset2 = msg.indexOf( '\n' );
		while( offset2 >= 0 ) {
			Label l = new Label( msg.substring( offset, offset2 ) );
			p.add( l );
			n++; offset = offset2 + 1;
			offset2 = msg.indexOf( '\n', offset2 + 1 );
		}
		p.add( new Label( msg.substring( offset ) ) );
		dlg.add( p, BorderLayout.NORTH );
    }
	public static void setPosition( Window parent, Dialog dlg ) {
		dlg.pack();
		dlg.setResizable( false );
		Point pt = parent.getLocation(); 	//@eEBhËʒu
		Dimension dim = parent.getSize();	//@eEBhȆ傫
		Dimension me = dlg.getSize();
		dlg.setLocation(
			pt.x + ( dim.width - me.width ) / 2,
			pt.y + ( dim.height - me.height ) / 2 );
	}
    //@{^ꂽ̏
    public void actionPerformed( ActionEvent e ) {
        ans = toID( e.getActionCommand() );
        dlg.hide();
    }
    //@{^ꂽ̏
    public void windowClosing( WindowEvent e ) {
        ans = MB_CANCEL;
        dlg.hide();
    }
    //@EBhEJꂽ̏
    public void windowOpened( WindowEvent e ) {
        //@ftHgtH[JX{^̐ݒ
        if( btnFocus != null ) btnFocus.requestFocus();
    }
}
