/**
*	XML to HTML AvP[V
*	
*	<BR>
*	Copyright(C) 2003 DEX. All Rights Reserved.
*
*	JDK 1.4.2ŃRpC
*	javax.xml.transform1.3.*ɂ͊܂܂Ȃ̂Œ(ȉDL\)
*	
*	Java XML Pack
*	http://java.sun.com/xml/downloads/javaxmlpack.html
*		
*	XV
*	2003/08/08	ver 0.04
*		-rIvVɊmFbZ[WoȂ悤ɕύX
*
*	2003/08/06	ver 0.03
*		R}hC͂ǉ
*		o̓eLXg{bNXD&D\ɕύX
*
*	2003/07/26	ver 0.02
*		̓t@CeLXgtB[hhbOhbvɑΉ
*		t[XN[ɕ\悤ɕύX
*
*	2003/07/26	ver 0.01
*		VK쐬
*/

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import gnu.getopt.*;

/// CNX
public class xml2htmlApp extends Frame implements ActionListener{
	public final static int ACTION_DEF = 0;
	public final static int ACTION_RUN = 1;
	String		strTitle = new String("XML to HTML Ver.0.04");
	Label			lbXml = new Label("XMLt@CF");
	Label			lbXsl = new Label("XSLt@CF");
	Label			lbHtml = new Label("oHTMLt@CF");
	Label			lbEncode = new Label("o̓GR[hF");
	Label			lbNull1 = new Label("");
	Label			lbNull2 = new Label("");
	Label			lbNull3 = new Label("");
	DropTextField	tfXml = new DropTextField();
	DropTextField	tfXsl = new DropTextField();
	DropTextField	tfHtml= new DropTextField();
	ChoiceEncode	ciEncode = new ChoiceEncode();	/// GR[hw
	MessageOut		err = new MessageOut(this);

	/// 又
	public static void main(String[] args){
		Frame f = new xml2htmlApp(args);
	}
	
	/// t[XN[̒Ɉړ
	void centerFrame(Frame f)
	{
		// ݂̃t[̑傫擾
		Dimension dimFrame = f.getSize();
		
		// XN[̑傫擾
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension dimScreen = toolkit.getScreenSize();

		// ̉ʏ̈ʒu𒆉ɐݒ肷
		f.setLocation( (int)( dimScreen.getWidth() - dimFrame.getWidth() ) / 2,
						 (int)( dimScreen.getHeight() - dimFrame.getHeight() ) / 2 );
	}
	
	/// iZbg
	xml2htmlApp(String[] args){
		setTitle(strTitle);
		setLayout(new GridLayout(5,3,4,4));
		Button btXml=new Button("OpenXml");
		Button btXsl=new Button("OpenXsl");
		Button btHtml=new Button("SaveHtml");
		Button btConvert=new Button("Convert");

		btXml.addActionListener(this);
		btXsl.addActionListener(this);
		btHtml.addActionListener(this);
		btConvert.addActionListener(this);

		add(lbXml);
		add(tfXml);
		add(btXml);

		add(lbXsl);
		add(tfXsl);
		add(btXsl);

		add(lbHtml);
		add(tfHtml);
		add(btHtml);
		
		add(lbEncode);
		add(ciEncode);
		add(lbNull1);
		
		add(lbNull2);
		add(btConvert);
		add(lbNull3);
		
		addWindowListener(new WinAdapter());
		setSize(400,150);
		centerFrame(this);
		parseOption(args);
		setResizable(false);
		setVisible(true);
	}

	/// 
	class WinAdapter extends WindowAdapter{
		public void windowClosing(WindowEvent we){System.exit(0);}
	}
	
	/// Cxg
	public void actionPerformed(ActionEvent ae){
		if(ae.getActionCommand()=="OpenXml"){
			String tmp = openfile("*.xml");
			if(tmp != "") tfXml.setText(tmp);
		}

		if(ae.getActionCommand()=="OpenXsl"){
			String tmp = openfile("*.xsl");
			if(tmp != "") tfXsl.setText(tmp);
		}

		if(ae.getActionCommand()=="SaveHtml"){
			String tmp = writefile("*.html");
			if(tmp != "") tfHtml.setText(tmp);
		}
		
		if(ae.getActionCommand()=="Convert"){
			actionConvert(ACTION_DEF);
		}
	}
	
	/// ϊ
	void actionConvert(int nAcrion){
			String file_xml = tfXml.getText().trim();
			String file_xsl = tfXsl.getText().trim();
			String file_html = tfHtml.getText().trim();

			if(file_xml.length() <= 0){
				err.Out("xmlt@Cw肵ĉB");
				return;
			}

			if(file_xsl.length() <= 0){
				err.Out("xslt@Cw肵ĉB");
				return;
			}

			if(file_html.length() <= 0){
				err.Out("ohtmlt@Cw肵ĉB");
				return;
			}
			
			if(nAcrion == ACTION_DEF && MessageBoxValues.MB_NO == MessageBox.show(this, "ϊJn܂B낵łH", "mF", MessageBoxValues.MB_YESNO)){
				return;
			}

			try{
				FileOutputStream fo = new FileOutputStream(file_html);
				PrintStream ps = new PrintStream(fo);

				// TransformerFactoryCX^X擾
				TransformerFactory factory = TransformerFactory.newInstance();
				// XSLt@Ctranceformer擾
				Transformer transformer = factory.newTransformer(new StreamSource(file_xsl));
				// o͂GR[fBOݒ
				transformer.setOutputProperty(OutputKeys.ENCODING, ciEncode.getSelectedItem());
				// Cfg
				transformer.setOutputProperty(OutputKeys.INDENT, "yes") ;
				// XMLt@CXSLTŕϊďo
				transformer.transform(new StreamSource(file_xml), 
				                      new StreamResult(ps));
				ps.close();
				fo.close();
				
				err.Out("ȉɏo͂܂B\n" + file_html);
			}
			catch(Exception e){
				e.printStackTrace();
				err.Out("ϊɎs܂\n" + e.getMessage());
			}
			
			if(nAcrion == ACTION_RUN){
				System.exit(0);
			}
	}

	/// I[v_CAO
	String openfile(String filter){
		FileDialog fd=new FileDialog(new Frame(), "File Select", FileDialog.LOAD);
		fd.setFile(filter);
		fd.show();
		String fullpath = "";
		if(fd.getDirectory() != null && fd.getFile() != null){
			fullpath = fd.getDirectory() + fd.getFile();
		}
		fd.dispose();
		return fullpath;
	}
	
	/// Z[u_CAO
	String writefile(String filter){
		FileDialog fd=new FileDialog(new Frame(),"File Save",FileDialog.SAVE);
		fd.setFile(filter);
		fd.show();
		String fullpath = "";
		if(fd.getDirectory() != null && fd.getFile() != null){
			fullpath = fd.getDirectory() + fd.getFile();
		}
		fd.dispose();
		return fullpath;
	}
	
	/// IvV
	void parseOption(String args[]){
		Getopt g = new Getopt(strTitle, args, "x:s:o:rh");
		int c;
		String arg;
		while((c = g.getopt()) != -1){
			switch(c){
			case 'x': /* '-x' xmlt@Cw */
				tfXml.setText(g.getOptarg());
				break;
			case 's': /* '-s' xslt@Cw */
				tfXsl.setText(g.getOptarg());
				break;
			case 'o': /* '-o' o̓t@Cw */
				tfHtml.setText(g.getOptarg());			
				break;
			case 'r': /* '-r' ɕϊs */
				err.SelectDevice(MessageOut.DEVICE_STDERR);
				actionConvert(ACTION_RUN);
				err.SelectDevice(MessageOut.DEVICE_DIALOG);
				break;
			case 'h': /* '-h' wv */
				String help = strTitle + " help\n"
									+"-x <xml file>\n"
									+"-s <xsl file>\n"
									+"-o <output file>\n"
									+"-r : run a conversion\n"
									+"-h : this help\n";
				err.Out(help);
				break;
			default:
				break;
			}
			
			for (int i = g.getOptind(); i < args.length ; i++){
				/* IvVw肳ĂȂ擾 */
				// arg = args[i]
			}
		}
	}
}

// EOF