/**
* @hbOhbvΉeLXgtB[h
* <BR>
*
*	XV
*	2003/07/26	VK쐬
*/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.util.*;
import java.util.List;

class DropTextField extends TextField implements DropTargetListener{
	public DropTextField() {
		super();
		new DropTarget(this, DnDConstants.ACTION_COPY_OR_MOVE, this, true);
		setVisible(true);
	}

	/// hbOhbv
	public void dragEnter(DropTargetDragEvent dtde) {
		if(dtde.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
			dtde.acceptDrag(DnDConstants.ACTION_COPY_OR_MOVE);
		}
	}
   
	public void drop(DropTargetDropEvent dtde) {
		Transferable t = dtde.getTransferable();
		if(t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
			dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
			try {
				List fileList = (List)t.getTransferData(DataFlavor.javaFileListFlavor);

				// t@C̃pXǉ
				Iterator it = fileList.iterator();
				while (it.hasNext()) {
					File f = (File) it.next();
					setText(f.getAbsolutePath());
					break;	// 擪̂Pt@Ĉݏ
				}
				dtde.dropComplete(true);
			}
			catch(Exception e) {
				dtde.dropComplete(false);
				e.printStackTrace();
			}
		}else{
			dtde.rejectDrop();
		}
	}

	// --------------------------------------------------
	//  hbOhbvCxgp
	// --------------------------------------------------
	public void dragExit(DropTargetEvent e) {}
	public void dragOver(DropTargetDragEvent e) {}
	public void dropActionChanged(DropTargetDragEvent e) {}
}
